#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "xo"

const int MaxN = 3;

int a [MaxN] [MaxN];
int m;

bool win (int d)
{
 return a[0][0] == d && a[1][1] == d && a[2][2] == d ||
        a[0][2] == d && a[1][1] == d && a[2][0] == d ||
        a[0][0] == d && a[1][0] == d && a[2][0] == d ||
        a[0][1] == d && a[1][1] == d && a[2][1] == d ||
        a[0][2] == d && a[1][2] == d && a[2][2] == d ||
        a[0][0] == d && a[0][1] == d && a[0][2] == d ||
        a[1][0] == d && a[1][1] == d && a[1][2] == d ||
        a[2][0] == d && a[2][1] == d && a[2][2] == d;
}

int recur (int d)
{
 if (win (3 - d)) return 3 - d;
 if (m == MaxN * MaxN) return 0;
 int res, cur;
 int i, j;
 res = 3 - d;
 for (i = 0; i < MaxN; i++)
  for (j = 0; j < MaxN; j++)
   if (a[i][j] == 0)
   {
    a[i][j] = d; m++;
    cur = recur (3 - d);
    if (res == 3 - d) res = cur;
    if (cur == d) res = d;
    a[i][j] = 0; m--;
   }
 return res;
}

int main (void)
{
 int i, j;
 int x, o;
 int d;
 char ch;

 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 for (i = 0; i < MaxN; i++)
  for (j = 0; j < MaxN; j++)
  {
   scanf (" %c", &ch);
   switch (ch)
   {
    case 'X': a[i][j] = 1; break;
    case 'O': a[i][j] = 2; break;
    case '.': a[i][j] = 0; break;
    default: assert (false);
   }
  }

 x = o = 0;
 for (i = 0; i < MaxN; i++)
  for (j = 0; j < MaxN; j++)
   x += (a[i][j] == 1);
 for (i = 0; i < MaxN; i++)
  for (j = 0; j < MaxN; j++)
   o += (a[i][j] == 2);

 if (x < o || x > o + 1) printf ("Impossible\n");
 else
 {
  m = x + o;
  if (x == o) d = 1;
  else d = 2;
  if (win (1) && d == 1 || win (2) && d == 2) printf ("Impossible\n");
  else
  {
   d = recur (d);
   if (d == 0) printf ("Draw\n");
   else if (d == 1) printf ("X\n");
   else if (d == 2) printf ("O\n");
   else assert (false);
  }
 }
 return 0;
}
